// Picassobot - Robotic Drawing Arm kit
// Copyright (c) 2014 - The Educated Robot

void drawShape(Node temp){

  float x0=0;
  float y0=0;

  while (temp!=null){
    switch(temp.getKind()){
    case 'M':
      break;
    case 'L':
      line(x0,y0,temp.getX(),temp.getY());
      break;
    case 'E':
      ellipseMode(CORNERS);
      ellipse(x0,y0,temp.getX(), temp.getY());
      ellipseMode(CENTER);
      //ellipseMode(CENTER);
      //ellipse(x0,y0,abs(x0-temp.getX())*2, abs(y0-temp.getY())*2);
      break;
    case'C':
      if (temp.x1!=-1)//all point exist
        bezier(x0, y0, temp.cx1, temp.cy1, temp.cx2, temp.cy2, temp.getX(), temp.getY());
      else if (temp.cx2==-1) //
        bezier(x0, y0, temp.cx1, temp.cy1, mouseX, mouseY, mouseX, mouseY);
      else
        bezier(x0, y0, temp.cx1, temp.cy1, temp.cx2, temp.cy2, mouseX, mouseY);
      break;
    }//end of switch

    x0=temp.getX();
    y0=temp.getY();

    temp=temp.getNext();
  }//end of while
}//end of drawShape()




