// Picassobot - Robotic Drawing Arm kit
// Copyright (c) 2014 - The Educated Robot

/* video
int mShortLineLimit = 30; // 50 // Must be >= 2.
int mLineBendLimit = 3; // 20 // Must be >= 1;

  int maxX ; 
  int maxY;
  
  boolean [][] mPixels;
  boolean [][] mWalked;
  
  //Vector<Vector<Point>> mPointLists = new Vector<Vector<Point>>();
  
  int[][] mDirections = {{ 1, 0 }, 
                    { 1, 1 }, 
                    { 0, 1 }, 
                    { -1, 1 }, 
                    { -1, 0 }, 
                    { -1, -1 }, 
                    { 0, -1 }, 
                    { 1, -1 }};
                    
  int nX = 0;
  int nY = 0;
  int nDirection = 0;



  void raster2vector()
  {
    load(); // Put pixels in mPixels[x][y]
    walk();
    //simplify();
    //drawVectors();
    //buildVectorString();
  }
  
  void load()
  {
    int i = 0;
    maxX = imageWidth; 
    maxY = imageHeight;
    
    
    mPixels = new boolean[maxX][maxY];
    mWalked = new boolean[maxX][maxY];

    
//    mSketchy = sketchy;
//    mEdgeBitmap = source;
//    mVectorBitmap = vectorImage;
//    mVectorCanvas = vectorCanvas;
    
    for( int y = 0; y < maxY; y ++ )
    {
      if( y % 20 == 0 )
        updateProgress("Vectoriser load " + y + " / " + maxY  );

      for( int x = 0; x < maxX; x ++)
      {
        color c = edgeImg.pixels[i++];
        mPixels[x][y] = !(c == color(0xFF, 0xFF, 0xFF));
        mWalked[x][y] = false;
      }
    }
  }
  
  
  void walk()
  {
    for( int x = 1; x < maxX-1; x ++ )
    {
      updateProgress("Vectoriser walk " + x + " / " + maxX );


      for( int y = 1; y < maxY-1; y ++)
      {
        if( ! mWalked[x][y] )
          if( mPixels[x][y] )
            walkFrom( x, y );
      }
    }  
  
  }
  
  
void walkFrom( int x, int y )
  {
    mWalked[x][y] = true;

    //Vector<Point> v = new Vector<Point>();
    //v.add(new Point(x, y));
    // Add initial point to line shape
    curNode=new Node('M', x + paperOffsetX, y + paperOffsetY, null);
    curHead=curNode;
    
    int direction = 0;
    
    
    while( findNeighbour( x, y, direction ))
    {
      x = nX;
      y = nY;
      direction = nDirection;
      
      mWalked[x][y] = true;
      //v.add(new Point(x, y));
      // Add additional point to line shape
      if (dist(curNode.getX(), curNode.getY(), x + paperOffsetX, y + paperOffsetY) > 4) {
        curNode.setNext(new Node('L', x + paperOffsetX, y + paperOffsetY, null));
        curNode=curNode.getNext();
      }

    }
    
    //if( v.size() > mShortLineLimit ) // discard short lines
    //mPointLists.add( v );
    // Add line shape to shape list
    if(curNode.getKind()!='M')
      g_shapeList.add(curHead);
    curNode=null;
    curHead=null;
  }
  
  private boolean findNeighbour( int x, int y, int direction )
  {
    if( testNeighbour( x, y, direction))  // keep going the same way
      return true;
    
    // test neighbours, giving priority to the direction we are already headed
    return testNeighbour( x, y, direction - 1 ) ||
            testNeighbour( x, y, direction + 1 ) ||
            testNeighbour( x, y, direction - 2 ) ||            
            testNeighbour( x, y, direction + 2 ) ||
            testNeighbour( x, y, direction - 3 ) ||
            testNeighbour( x, y, direction + 3 ) ||
            testNeighbour( x, y, direction - 4 ) ||
            testNeighbour( x, y, direction + 4);
        
      
  }
  
  private boolean testNeighbour( int x, int y, int direction )
  {
    direction = (direction + 8) % 8;  // wrap to range
    int dx = mDirections[direction][0];
    int dy = mDirections[direction][1]; 
    
    x += dx;
    y += dy;
    
    if( x < 0 || x >= maxX || y < 0 || y >= maxY )  // off the edge
      return false;
    
    if( mPixels[x][y] && ! mWalked[x][y] )  // a set pixel that we haven't already consumed! Hurrah!
    {
      nDirection = direction;
      nX = x;
      nY = y;
      return true;
    }
    
    return false;
  }
*/  
  
